<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
<%- include('../partials/datepicker') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Editace soutěže</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="new-competition">
								<h6 class="heading text-muted mb-4">Základní údaje</h6>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col-sm-12 col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="name">Název</label>
												<input type="text" id="name" class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
										<div class="col-sm-12 col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="date">Datum</label>
												<div class="input-group">
													<div class="input-group-prepend">
														<span class="input-group-text">
															<i class="fas fa-calendar-alt"></i>
														</span>
													</div>
													<input class="form-control datepicker" id="date"
														placeholder="Vyberte prosím datum soutěže" type="text" required>
												</div>
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="league">Liga</label>
												<select class="form-control" id="league"></select>
											</div>
										</div>
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="categories">Kategorie</label>
												<select class="form-control" id="categories"
													multiple="multiple"></select>
											</div>
										</div>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="new-competition-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary">Vytvořit</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		$(document).ready(() => {
			API.competition
				.findById('<%= req.params.id %>')
				.done(function (competition) {
					let $name = $('input#name')
					$name.val(competition.name)

					let $date = $('input#date')
					$date.val(competition.date)

					let $leagueSelect = $('select#league').select2()
					API.league
						.list()
						.done(function (leagues) {
							for (let i = 0; i < leagues.length; i++) {
								$leagueSelect.append(
									$('<option>', { value: leagues[i]._id }).text(leagues[i].name)
								)
							}
						})

					let categoriesIds = []
					for (let i = 0; i < competition.categories.length; i++) {
						categoriesIds.push(competition.categories[i]._id)
					}

					let $categoriesSelect = $('select#categories').select2()
					API.category
						.list()
						.done(function (categories) {
							for (let i = 0; i < categories.length; i++) {
								let selected = categoriesIds.includes(categories[i]._id)
								$categoriesSelect.append(
									$('<option>', { value: categories[i]._id, selected: selected }).text(categories[i].name)
								)
							}
						})

					$('form#new-competition').submit(function (event) {
						event.preventDefault()
						let $status = $('div#new-competition-status')
						$status
							.empty()
							.append(
								$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
									$('<span>', { class: 'alert-icon' }).append(
										$('<i>', { class: 'fas fa-circle-notch fa-spin' })
									),
									$('<span>', { class: 'alert-text' }).append(
										$('<strong>').text('Zpracovávám'),
										' Vyčkejte prosím'
									),
									$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
										$('<span>', { 'aria-hidden': 'true' }).html('&times;')
									)
								)
							)
							.show()

						API.competition
							.edit('<%= req.params.id %>', $name.val(), $date.val(), $leagueSelect.val(), $categoriesSelect.val())
							.done(function (responseFromServer) {
								if (responseFromServer === 'ok') {
									$status
										.empty()
										.append(
											$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
												$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
												$('<strong>').text('Gratuluji!'),
												' Úspěšně jste upravil(a) soutěž'
											)
										)
										.show()

									// Reload page
									setTimeout(function () {
										window.location.href = window.location.href;
									}, 3500)
								} else {
									$status
										.empty()
										.append(
											$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
												$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
												$('<strong>').text('Ach ne! '),
												responseFromServer
											)
										)
										.show()
								}
							})
					})
				})
		})
	</script>
	<%- include('../partials/file-end') %>